#include "../includes/main.h"

/*---------------devis---------------*/

// Chargement de l'adresse depuis un fichier
char *readAdress(FILE *flot)
{
	char *adresse, *s, aux[5];
	int i=0, tmax=5;
	adresse = (char *)malloc(sizeof(char)*tmax);
	fgets(adresse, 5, flot);

	while (adresse[i]!='\n')
	{
		if (i==tmax - 1)
		{
			tmax+=5;
			s = (char *)realloc(adresse, tmax*sizeof(char));
			if (s==NULL)
			{
				printf("\033[0;31mErreur: \033[0mreallocation pour str adresse\n");
				exit(1);
			}
			adresse=s;
			fgets(aux, 5, flot);
			strcat(adresse, aux);
		}
		i++;
	}
	adresse[strlen(adresse)-1]='\0';
	return adresse;
}

// Chargement d'un devis depuis un fichier
Devis loadDevis(Offre *tabTravaux[])
{
	Devis d;
	FILE *devisFile;
	devisFile = fopen("../devis/txt", "r");
	char travaux[16];
	int index;
	scanf("%s", travaux);
	index = rechTravaux(travaux, tabTravaux);
	if (index==-1)
	{
		printf("\033[0;31mErreur: \033[0mCes travaux ne sont pas prévus !\n");
		exit(1);
	}
	fgets(d.nomE, 32, devisFile);
	d.nomE[strlen(d.nomE)-1] = '\0';
	d.adresse = readAdress(devisFile);
	fscanf(devisFile, "%d\n%d\n%d", &d.capital, &d.duree, &d.prix);
	fclose(devisFile);
	return d;
}


// Chargement des tâches depuis un fichier pour chaque offre
Tache **loadTaches(Offre *tabTravaux[])
{
	Precedence *prec;
	int i, tmaxPrec=5, tlogPrec;
	Tache *t, **tabTache;
	tabTache = (Tache **)malloc(8*sizeof(Tache *));
	if (tabTache == NULL)
	{
		printf("\033[0;31mErreur: \033[0mmalloc tableau tache\n");
		exit(1);
	}
	for (i=0; i<tmaxTravaux; i++)
	{
		t=(Tache *)malloc(sizeof(Tache));
		if (t==NULL)
		{
			printf("\033[0;31mErreur: \033[0mmalloc tache\n");
			exit(1);
		}

		strcpy(t->tache, tabTravaux[i]->travaux);
		t->duree = ((tabTravaux[i]->ldevis)->dev).duree;

		prec = loadPrec(&tmaxPrec, &tlogPrec);

		t->nbPred = nombrePred(tabTravaux[i]->travaux, prec, tlogPrec);

		t->dateDebut=0;
		t->traite=0;

		tabTache[i] = t; 
	}
	return tabTache;
}

/*--------------precedences--------------*/

// Chargement des précédences depuis un fichier
Precedence *loadPrec(int *tmax, int *tlog)
{
	FILE *prec;
	Precedence *tabP, *s;
	prec=fopen("../files/précédence.txt", "r");
	if (prec == NULL)
	{
		printf("\033[0;31mErreur: \033[0mouverture de 'précédence.txt'\n");
		exit(1);
	}
	tabP = (Precedence *)malloc((*tmax) * sizeof(Precedence));
	while(!feof(prec))
	{
		if(*tlog==*tmax)
		{
			(*tmax)+=5;
			s = (Precedence *)malloc((*tmax) * sizeof(Precedence));
			if (s==NULL)
			{
				printf("\033[0;31mErreur: \033[0mreallocation pour fichier précédence\n");
				exit(1);
			}
			tabP = s;
		}
		fscanf(prec, "%s%s", tabP[*tlog-1].travauxPrec, tabP[*tlog-1].travauxSucc);
		(*tlog)++;
	}
	fclose(prec);
	return tabP;
}
