#include "../includes/main.h"

/*-------------recherches-------------*/

// Recherche d'une offre dans le tableau de travaux
// Retourne l'indice de l'offre dans le tableau si elle est trouvée, sinon retourne -1
int rechTravaux(char *travauxName, Offre *tabTravaux[])
{
	//On utilise la taille max de travaux car travaux est un tableau constant, sa taille max est égale à sa taille logique.
	int deb=0, end=tmaxTravaux-1, mid;
	while(deb<=end)
	{
		mid = (deb+end) /2;
		if (strcmp(travauxName, tabTravaux[mid]->travaux)==0)
			return mid;
		if (strcmp(travauxName, tabTravaux[mid]->travaux) < 0)
			end=mid-1;
		else
			deb=mid+1;
	}
	return -1;
}

// Recherche et garde la meilleure offre par travaux dans le tableau
// Affiche chaque offre gardee avec le devis ayant le prix le plus bas
void minTravaux(Offre *tabTravaux[])
{
	int i;
	ListeDevis l, minl;
	for (i=0; i<tmaxTravaux; i++)
	{
		l=tabTravaux[i]->ldevis;
		minl=l;
		while(l)
		{
			if(l->dev.prix < minl->dev.prix)
			{
				l=delete(minl);
				minl=l;
			}
			else 
				l=delete(l);
			l=l->suiv;
		}
		displayOffre(tabTravaux[i]);
	}
}


/*---------------tri------------------*/

//on la met dans struct.c ?

// Libère la mémoire d'une liste de devis
void 	freeListeDevis(ListeDevis *ldevis)
{
	ListeDevis current = *ldevis;
	ListeDevis next;

	while (current) 
	{
		next = current->suiv;
		free(current);
		current = next;
	}
	*ldevis = NULL;
}

// Boucle principale de fusion de listes de devis
void	fusionDevisElements(ListeDevis *R, int *tlogR, ListeDevis *S, int *tlogS, ListeDevis *mergedList, ListeDevis *last, int *k)
{
	ListeDevis	*current;

	while (*tlogR > 0 && *tlogS > 0)
	{
		if (strcmp((*R)->dev.nomE, (*S)->dev.nomE) < 0)
		{
			current = R;
			(*tlogR)--;
		}
		else
		{
			current = S;
			(*tlogS)--;
		}
		if (!(*mergedList))
		{
			*mergedList = (ListeDevis)malloc(sizeof(MaillonDevis));
			*last = *mergedList;
		}
		else
		{
			(*last)->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
			*last = (*last)->suiv;
		}
		(*last)->dev = (*current)->dev;
		*current = (*current)->suiv;
		(*last)->suiv = NULL;
		(*k)++;
	}
}

// Gère les éléments restants après les itérations principales de fusion
void	gestionElementsRestants(ListeDevis *mergedList, ListeDevis *last, ListeDevis *source, int *tlogSource, int *k)
{
	while (*tlogSource > 0)
	{
		if (!*mergedList)
			*mergedList = *last = (ListeDevis)malloc(sizeof(MaillonDevis));
		else
		{
			(*last)->suiv = (ListeDevis)malloc(sizeof(MaillonDevis));
			*last = (*last)->suiv;
		}
		(*last)->dev = (*source)->dev;
		*source = (*source)->suiv;
		(*last)->suiv = NULL;
		(*k)++;
		(*tlogSource)--;
	}
}

// Fusionne deux listes de devis triées en une seule liste triée
void	fusionMaillonDevis(ListeDevis R, int tlogR, ListeDevis S, int tlogS, ListeDevis *T)
{
	ListeDevis	last;
	ListeDevis	mergedList;
	int		k;

	last = NULL;
	mergedList = NULL;
	k = 0;
	fusionDevisElements			(&R, &tlogR, &S, &tlogS, &mergedList, &last, &k);
	gestionElementsRestants			(&mergedList, &last, &R, &tlogR, &k);
	gestionElementsRestants			(&mergedList, &last, &S, &tlogS, &k);
	freeListeDevis(T);
	*T = mergedList;
}

// Tri fusion sur une liste de devis
void	triFusionListeDevis(ListeDevis *ldevis, int tlog)
{
	ListeDevis	p;
	ListeDevis	q;
	ListeDevis	qTemp;

	p = *ldevis;
	q = p->suiv;
	if (tlog <= 1)
		return;
	for (int i = 0; i < tlog / 2 - 1 && q && q->suiv; i++)
	{
		p = p->suiv;
		q = q->suiv->suiv;
	}
	qTemp = p->suiv;
	p->suiv = NULL;
	triFusionListeDevis(ldevis, tlog / 2);
	triFusionListeDevis(&qTemp, tlog - tlog / 2);
	ListeDevis mergedList = NULL;
	fusionMaillonDevis(*ldevis, tlog / 2, qTemp, tlog - tlog / 2, &mergedList);
	*ldevis = mergedList;
}
