#include "../includes/main.h"

/*----------initialisations ----------*/

// Initialise une liste de devis
ListeDevis newListeDevis(void)
{
	return NULL;
}

// Initialise une liste de travaux
Liste newListe(void)
{
	return NULL;
}

// Initialise une nouvelle offre
Offre newOffre(char *travauxName)
{
	Offre o;
	strcpy(o.travaux, travauxName);
	o.ldevis=newListeDevis();
	return o;
}

/*------------verifications------------*/

// Verifie l'integrite d'une liste de devis
Booleen emptyListe(ListeDevis l)
{
	return l==NULL;
}

// Vérifie l'intégrité de l'offre
Booleen emptyOffre(Offre *o)
{
	return emptyListe(o->ldevis);
}

/*-------------insertions---------------*/

// Insere un devis dans la liste de devis
ListeDevis insert(ListeDevis l, Devis d)
{
	MaillonDevis *md;
	md = (MaillonDevis *)malloc(sizeof(MaillonDevis));
	if (md == NULL)
	{
		printf("\033[0;31mErreur: \033[0mallocation mémoire insertion MaillonDevis\n");
		exit(1);
	}
	md->dev=d;
	md->suiv=l;
	return md;
}

// Insere une liste dans le tableau de travaux
Liste insertSucc(Liste l, char travaux[])
{
	MaillonSucc *ms;
	ms = (MaillonSucc *)malloc(sizeof(MaillonSucc));
	if (ms == NULL)
	{
		printf("\033[0;31mErreur: \033[0mmalloc liste successeurs\n");
		exit(1);
	}
	ms->nxt=l->nxt;
	l->nxt=ms;
	strcpy(ms->tache, travaux);
	return l;
}

/*------------suppressions-------------*/

// Supprime le premier maillon de la liste de devis
ListeDevis delete(ListeDevis l)
{
	MaillonDevis *md;
	if (l==NULL)
	{
		printf("\033[0;31mErreur: \033[0msuppression dans une liste vide\n");
		exit(1);
	}
	md=l;
	l=l->suiv;
	free(md);
	return l;
}

/*---------------calculs----------------*/

// Calcule la longueur de la liste de devis
int lenListeDevis(ListeDevis l)
{
	int len=0;
	while (l)
	{
		len++;
		l=l->suiv;
	}
	return len;
}

// Calcule le nombre de precedences pour un travail donne
int nombrePred(char travaux[], Precedence prec[], int tlog)
{
	int nbPred = 0, i;
	for (i=0; i<tlog; i++)
		if (strcmp(travaux, prec[i].travauxSucc)==0)
			nbPred++;
	return nbPred;
}

/*--------------informations------------*/

// Retourne une liste des successeurs pour un travail donne
Liste lstSucc(char travaux[], Precedence prec[], int tlog)
{
	Liste succ = newListe();
	int i;
	for (i=0; i<tlog; i++)
		if(strcmp(travaux, prec[i].travauxPrec)==0)
			succ=insertSucc(succ, prec[i].travauxSucc);
	return succ;
}

/*---------------affichages--------------*/

// Affiche les details d'un devis
void displayDevis(Devis d)
{
	printf("%s\t%s\t%d\t%d\t%d\n", d.nomE, d.adresse, d.capital, d.duree, d.prix);
}

// Affiche les details de l'offre et sa liste de devis
void displayOffre(Offre *o)
{
	printf("Travaux: %s", o->travaux);
	displayListeDevis(o->ldevis);
}

// Affiche les details de la liste de devis
void displayListeDevis(ListeDevis l)
{
	while(l)
	{
		displayDevis(l->dev);
		l=l->suiv;
	}
}